without trace
without warning

include diatui.e  


constant color_seq={"BLACK","BLUE","GREEN","CYAN","RED","MAGENTA",
"BROWN","WHITE"}

integer inifile,choice 
sequence password,itemnames,itemcode
integer fg,bg,itemcount,menucount,adjitemcount
entity mnuMain,mnuColor1,mnuColor2,txtBox,inpPW,inpProg,yn1,yn2,colorBase
sequence colorItems
sequence mnuProg  
sequence boxes  

mnuMain=call_method(Menu,"new",NONE) 
VOID=call_method(mnuMain,"Set_Text",{"MAIN MENU"})

mnuColor1=call_method(Menu,"new",NONE)
for i=1 to 8 do
   VOID=call_method(mnuColor1,"Add_Item",{color_seq[i]})
end for                                      

mnuColor2=call_method(Menu,"new",NONE)
VOID=call_method(mnuColor2,"Set_Text",{"Select Final Colors"})
for i=1 to 4 do
   VOID=call_method(mnuColor2,"Add_Item",{"Like This"})   
end for                

mnuProg=NONE

txtBox=call_method(Text_Box,"new",NONE)

inpPW=call_method(Input_Box,"new",NONE)
VOID=call_method(inpPW,"Set_Limits",{6,16})
VOID=call_method(inpPW,"Set_Echo",{'*'})

inpProg=call_method(Input_Box,"new",NONE)           

yn1=call_method(Yes_No_Box,"new",NONE)
VOID=call_method(yn1,"Set_Text",{"Accept these colors?"})

yn2=call_method(Yes_No_Box,"new",NONE)
VOID=call_method(yn2,"Set_Text",
{"Do you want to add this program to the program menu?"})


boxes={mnuMain,mnuColor1,mnuColor2,txtBox,inpPW,inpProg,yn1,yn2}

colorBase=call_method(Color,"new",{BRIGHT_WHITE,BLACK}) 

colorItems=repeat(NONE,9)
for i=1 to 9 do
   colorItems[i]=call_method(colorBase,"clone",NONE)
end for                                                

procedure set_all_colors()
   VOID=call_method(Screen,"Set_Color",{colorBase})
   for i=1 to length(boxes) do
      VOID=call_method(boxes[i],"Set_Color",{colorBase})   
   end for
end procedure

function getline()
   integer len
   object line
   line=gets(inifile)
   if atom(line) then return line end if
   len=length(line)
   while TRUE do   
      if not find(line[len],"\n\r") then return line end if
      len-=1
      line=line[1..len]
      if len=0 then return line end if
   end while
end function  

function good_password()
   integer char
   for i=1 to length(password) do
      char=password[i]
      if char<'0' then return FALSE end if
      if char>'9' and char<'A' then return FALSE end if
      if char>'Z' and char<'a' then return FALSE end if
      if char>'z' then return FALSE end if
   end for
   return TRUE      
end function

procedure set_password()      
   integer char
   sequence confirm
   VOID=call_method(Screen,"Clear",NONE)
   VOID=call_method(txtBox,"Set_Color",{colorBase})
   VOID=call_method(txtBox,"Set_Text",
   {"Please enter a password (6 to 16 letters and digits, case sensitive):"})
   VOID=call_method(inpPW,"Set_Color",{colorBase})
   VOID=call_method(txtBox,"Display",NONE)
   while TRUE do
      while TRUE do
         password=call_method(inpPW,"Display",NONE)
         if good_password() then exit end if
         VOID=call_method(txtBox,"Set_Text",
         {"Invalid password.  Please re-enter:"})   
         VOID=call_method(txtBox,"Display",NONE)
      end while
      VOID=call_method(txtBox,"Set_Text",{"Please confirm password:"})
      VOID=call_method(txtBox,"Display",NONE)
      confirm=call_method(inpPW,"Display",NONE)
      if equal(confirm,password) then exit end if
      VOID=call_method(txtBox,"Set_Text",
      {"Passwords do not match.  Please re-enter:"})
      VOID=call_method(txtBox,"Display",NONE)
   end while
end procedure                                  

procedure select_color() 
   while TRUE do                                
      VOID=call_method(mnuColor1,"Set_Color",{colorBase})
      VOID=call_method(mnuColor1,"Set_Text",{"Select Foreground Color"})
      for i=1 to 8 do
         VOID=call_method(colorItems[i],"Set",{i-1,(i=1)*7})
         VOID=call_method(mnuColor1,"Edit_Item",
         {i,color_seq[i],colorItems[i]})
      end for                                                                 
      fg=call_method(mnuColor1,"Display",NONE)-1
      VOID=call_method(colorItems[9],"Set",{fg,bg})
      VOID=call_method(mnuColor1,"Set_Color",{colorItems[9]})
      VOID=call_method(mnuColor1,"Set_Text",{"Select Background Color"})
      for i=1 to 8 do
         VOID=call_method(colorItems[i],"Set",{fg,i-1})
         VOID=call_method(mnuColor1,"Edit_Item",
         {i,color_seq[i],colorItems[i]})   
      end for                                                                 
      bg=call_method(mnuColor1,"Display",NONE)-1
      VOID=call_method(colorItems[9],"Set",{fg,bg})
      VOID=call_method(mnuColor2,"Set_Color",{colorItems[9]})
      for i=1 to 4 do
         VOID=call_method(colorItems[i],"Set",{fg+(i-1)*8,bg})   
         VOID=call_method(mnuColor2,"Edit_Item",
         {i,"Like This",colorItems[i]})
      end for
      fg+=(call_method(mnuColor2,"Display",NONE)-1)*8
      VOID=call_method(colorItems[9],"Set",{fg,bg})
      VOID=call_method(yn1,"Set_Color",{colorItems[9]})
      if call_method(yn1,"Display",NONE)=TRUE then exit end if
      fg=call_method(colorBase,"Get_Foreground",NONE)
      bg=call_method(colorBase,"Get_Background",NONE)
   end while
   VOID=call_method(colorBase,"Set",{colorItems[9]})
   set_all_colors()
end procedure  

procedure launch_program(sequence name,sequence cmd) 
   if length(cmd)>0 and cmd[length(cmd)]='?' then
      cmd=cmd[1..length(cmd-1)]
      VOID=call_method(txtBox,"Set_Text",
      {"Please enter command line parameters for "&name&":"})
      VOID=call_method(txtBox,"Display",NONE)
      cmd&=call_method(inpProg,"Display",NONE)
   end if 
   system(cmd,2)     
end procedure

procedure menu_launch()
   integer menuptr,numitems,key,index
   if itemcount=0 then return end if
   menuptr=1
   while TRUE do
      if menuptr=menucount then
         numitems=remainder(itemcount,8)
         if numitems=0 then numitems=8 end if
      else
         numitems=8   
      end if
      key=call_method(mnuProg[menuptr],"Display",NONE)
      if key>numitems then
         if menucount=1 then return end if
         if key>numitems+1 then return end if
         menuptr+=1
         if menuptr>menucount then menuptr=1 end if
      else                            
         index=key+menuptr*8-8
         launch_program(itemnames[index],itemcode[index])
      end if  
   end while
end procedure                                            

procedure new_launch()
   sequence cmd
   VOID=call_method(txtBox,"Set_Text",{"Please enter command line:"})
   VOID=call_method(txtBox,"Display",NONE)
   cmd=call_method(inpProg,"Display",NONE)
   launch_program("this program",cmd)
   if call_method(yn2,"Display",NONE)=FALSE then return end if
   VOID=call_method(txtBox,"Set_Text",{"Please enter program name:"})
   VOID=call_method(txtBox,"Display",NONE)
   itemnames=append(itemnames,call_method(inpProg,"Display",NONE))
   itemcode=append(itemcode,cmd)
   adjitemcount+=1
end procedure

procedure noini()
   fg=BRIGHT_WHITE
   bg=BLACK
   itemcount=0 
   itemnames=NONE
   itemcode=NONE
   set_password()
   select_color()   
end procedure

procedure readini()
   object line   
   inifile=open("progstrt.ini","r")
   if inifile=-1 then noini() return end if
   line=getline()
   if atom(line) then noini() return end if   
   password=255-line
   line=getline()
   if atom(line) then noini() return end if
   line=value(line)
   if line[1]!=GET_SUCCESS then noini() return end if
   fg=line[2]
   line=getline()
   if atom(line) then noini() return end if
   line=value(line)
   if line[1]!=GET_SUCCESS then noini() return end if 
   bg=line[2]
   line=getline()
   if atom(line) then noini() return end if
   line=value(line)
   if line[1]!=GET_SUCCESS then noini() return end if
   itemcount=line[2]                
   itemnames=NONE
   itemcode=NONE
   for i=1 to itemcount do
      line=getline()
      if atom(line) then noini() return end if
      itemnames&={line}
      line=getline()
      if atom(line) then noini() return end if
      itemcode&={line}
   end for 
   close(inifile) 
   VOID=call_method(colorBase,"Set",{fg,bg})
   set_all_colors()
   VOID=call_method(txtBox,"Set_Text",{"Please enter your password:"})
   VOID=call_method(Screen,"Clear",NONE)
   for i=1 to 3 do
      VOID=call_method(txtBox,"Display",NONE)
      if equal(password,call_method(inpPW,"Display",NONE)) then 
         return
      end if
      VOID=call_method(txtBox,"Set_Text",
      {"Invalid password.  Please re-enter."})         
   end for 
   abort(0)
end procedure         

procedure writeini()
   inifile=open("progstrt.ini","w")
   if inifile=-1 then return end if
   printf(inifile,"%s\n",{255-password}) 
   printf(inifile,"%d\n",fg)
   printf(inifile,"%d\n",bg)
   printf(inifile,"%d\n",adjitemcount)
   for i=1 to adjitemcount do
      printf(inifile,"%s\n",itemnames[i..i])
      printf(inifile,"%s\n",itemcode[i..i])     
   end for                                 
   close(inifile)   
end procedure



readini()
adjitemcount=itemcount 
             
VOID=call_method(mnuMain,"Add_Item",{"Change Password"})
VOID=call_method(mnuMain,"Add_Item",{"Select Screen Colors"})
VOID=call_method(mnuMain,"Add_Item",{"Launch Program From Menu"})
VOID=call_method(mnuMain,"Add_Item",{"Launch New Program"})
VOID=call_method(mnuMain,"Add_Item",{"Exit"})

menucount=0                                    
for i=1 to floor((itemcount+7)/8) do
   mnuProg&={call_method(Menu,"new",NONE)}
   menucount+=1
   VOID=call_method(mnuProg[i],"Set_Color",{colorBase})
   VOID=call_method(mnuProg[i],"Set_Text",{"LAUNCH PROGRAM"})  
   for j=i*8-7 to i*8 do  
      if j>itemcount then exit end if
      VOID=call_method(mnuProg[i],"Add_Item",{itemnames[j]})      
   end for                                               
   if itemcount>8 then
      VOID=call_method(mnuProg[i],"Add_Item",{"More Programs . . ."})
   end if
   VOID=call_method(mnuProg[i],"Add_Item",{"Return to Main Menu"})
end for   

while TRUE do
   choice=call_method(mnuMain,"Display",NONE) 
   if choice=1 then 
      set_password()
   elsif choice=2 then 
      select_color()
   elsif choice=3 then
      menu_launch()
   elsif choice=4 then
      new_launch()
   else
      writeini() 
      exit  
   end if
end while
  


