-- animal.e class hierarchy for benchmark tests.
-- Adapted from Rod Jackson's Quartz.
include ../diamond.e
without warning
without trace


procedure my_sound (integer f)
end procedure


global constant Animal=class("Animal",NORMAL,Entity,NONE)

property("Name",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,NONE) 
property("IsDomesticated",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,FALSE)

function Animal_new_2(object name,object isDomesticated)
   entity new 
   new=call_method(super(),"new",NONE)
   set_property(new,"Name",name)
   set_property(new,"IsDomesticated",isDomesticated)
   return new
end function

method("new",0,CLASS,NORMAL,PROTECTED,SUPER_METHOD,NONE)
method("new",1,CLASS,NORMAL,PUBLIC,routine_id("Animal_new_2"),{FALSE})
method("new",2,CLASS,NORMAL,PUBLIC,routine_id("Animal_new_2"),NONE) 

method("clone",0,INSTANCE,NORMAL,PUBLIC,SUPER_METHOD,NONE)

method("delete",0,INSTANCE,NORMAL,PUBLIC,SUPER_METHOD,NONE)

function Animal_MakeNoise_0()      
   my_sound(800)
   my_sound(0)
   return NIL
end function

method("MakeNoise",0,INSTANCE,NORMAL,PUBLIC,
routine_id("Animal_MakeNoise_0"),NONE)

end_class()


global constant Mammal=class("Mammal",NORMAL,Animal,NONE)

property("HasTail",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,TRUE)
property("HasFur",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,TRUE)
property("IsAquatic",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,FALSE)

function Mammal_new_5 (object name, object isDomesticated,object hasTail,
object hasFur,object isAquatic)
   entity new
   new=call_method(super(),"new",{name,isDomesticated})
   set_property(new,"HasTail",hasTail)
   set_property(new,"HasFur", hasFur)
   set_property(new,"IsAquatic",isAquatic)
   return new
end function


method("new",1,CLASS,NORMAL,PUBLIC,routine_id("Mammal_new_5"),
{FALSE,TRUE,TRUE,FALSE})
method("new",2,CLASS,NORMAL,PUBLIC,routine_id("Mammal_new_5"),
{TRUE,TRUE,FALSE})
method("new",3,CLASS,NORMAL,PUBLIC,routine_id("Mammal_new_5"),{TRUE,FALSE})
method("new",4,CLASS,NORMAL,PUBLIC,routine_id("Mammal_new_5"),{FALSE})
method("new",5,CLASS,NORMAL,PUBLIC,routine_id("Mammal_new_5"),NONE)

end_class()


global constant Bird=class("Bird",NORMAL,Animal,NONE)

property("Wingspan",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,0)
property("MaxSpeed",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,0)

end_class()


global constant Fish=class("Fish",NORMAL,Animal,NONE)

function Fish_MakeNoise_0()
    -- no sound             
    my_sound(0)
   return NIL
end function

method("MakeNoise",0,INSTANCE,NORMAL,PUBLIC,
routine_id("Fish_MakeNoise_0"),NONE)

end_class()


global constant Cat=class("Cat",NORMAL,Mammal,NONE)

property("IsDeclawed",INSTANCE,PUBLIC,PUBLIC,PERSISTENT,FALSE)

end_class()


global constant Dog=class("Dog",NORMAL,Mammal,NONE)

end_class()



