-- ddelegat.e v4.0.0 by Mike Nelson
-- Diamond Standard Class Library
-- C# style delegates (can wrap proeprties and events as well as methods).       

without trace 
without warning

include dexcept.e

type valid_param_count(object x)
   if integer(x) then
      if x>=0 then return TRUE end if
   end if                            
   throw(Type_Check_Failure)
   return TRUE
end type    

constant SPECIAL_HANDLERS={DEFAULT_HANDLER,NULL_HANDLER,CURRENT_HANDLERS}

type valid_id(object x)
   if integer(x) then
      if x>=0 or find(x,SPECIAL_HANDLERS) then return TRUE end if
   end if    
   return FALSE
end type          

type valid_handler(object x)          
   integer flag
   if valid_id(x) then return TRUE end if
   if sequence(x) then 
      flag=TRUE
      for i=1 to length(x) do
         if not valid_id(x) then 
            flag=FALSE
            exit
         end if
      end for
      if flag=TRUE then return TRUE end if
   end if                                 
   throw(Type_Check_Failure)
   return TRUE
end type           

type param_sequence(object x)
   if sequence(x) then
      if length(x)=get_property(this(),"Param_Count") then return TRUE end if
   end if 
   throw(Type_Check_Failure)
   return TRUE
end type

global constant DELEGATE_PROPERTY=1
global constant DELEGATE_PROPERTY_GET=2
global constant DELEGATE_PROPERTY_SET=3
global constant DELEGATE_METHOD=4
global constant DELEGATE_EVENT=5
global constant DELEGATE_EVENT_LINK=6
global constant DELEGATE_EVENT_RAISE=7

constant GETTER={DELEGATE_PROPERTY,DELEGATE_PROPERTY_GET}
constant SETTER={DELEGATE_PROPERTY,DELEGATE_PROPERTY_SET}
constant LINKER={DELEGATE_EVENT,DELEGATE_EVENT_LINK}
constant RAISER={DELEGATE_EVENT,DELEGATE_EVENT_RAISE}

type valid_type(object x)
   if integer(x) then
      if x>=DELEGATE_PROPERTY and x<=DELEGATE_EVENT_RAISE then
         return TRUE
      end if
   end if           
   throw(Type_Check_Failure)
   return TRUE
end type



package("Diamond Standard Class Library")   


global constant Access_Denied=exception("Access_Denied",Not_Allowed)

global constant Wrong_Delegate_Type=
exception("Wrong_Delegate_Type",Not_Allowed)


global constant Delegate=class("Delegate",NORMAL,Entity,Clonable)

global type is_Delegate(object x)
   return live_instance_check(x,Delegate)   
end type

property("Type",INSTANCE,PUBLIC,PRIVATE,PERSISTENT,NIL)
property("Target",INSTANCE,PRIVATE,PRIVATE,PERSISTENT,Null_Instance)
property("Name",INSTANCE,PRIVATE,PRIVATE,PERSISTENT,NONE)
property("Param_Count",INSTANCE,PRIVATE,PRIVATE,PERSISTENT,0)   

method("new",0,CLASS,NORMAL,PROTECTED,NULL_METHOD,{Null_Instance})

function Delegate_new_4(valid_type dType,is_entity target,is_identifier name,
valid_param_count params)  
   entity new
   if not success() then return Null_Instance end if
   if params!=0 then
      if dType<DELEGATE_METHOD then
         throw(Type_Check_Failure)
         return Null_Instance   
      end if
   end if       
   while TRUE do
      if find(dType,GETTER) then
         if can_get(target,name)=FALSE then exit end if 
      end if
      if find(dType,SETTER) then
         if can_set(target,name)=FALSE then exit end if
      end if                                     
      if dType=DELEGATE_METHOD then
         if can_call(target,name,repeat(NIL,params))=FALSE then exit end if
      end if                                                               
      if find(dType,LINKER) then
         if can_link(target,sprintf("%s#%d",{name,params}))=FALSE then
            exit   
         end if
      end if  
      if find(dType,RAISER) then
         if can_raise(target,name,repeat(NIL,params))=FALSE then exit end if
      end if
      new=call_method(super(),"new",NONE) 
      set_property(new,"Type",dType)
      set_property(new,"Target",target)
      set_property(new,"Name",name) 
      set_property(new,"Param_Count",params)
      return new      
   end while 
   throw(Access_Denied)
   return Null_Instance  
end function    

method("new",3,CLASS,NORMAL,PUBLIC,routine_id("Delegate_new_4"),{0})
method("new",4,CLASS,NORMAL,PUBLIC,routine_id("Delegate_new_4"),NONE) 

method("clone",0,INSTANCE,NORMAL,PUBLIC,SUPER_METHOD,NONE) 

method("delete",0,INSTANCE,NORMAL,PUBLIC,SUPER_METHOD,NONE)

function Delegate_Get_0() 
   sequence name
   entity target
   if not find(get_property(this(),"Type"),GETTER) then
      throw(Wrong_Delegate_Type)
      return NIL   
   end if 
   target=get_property(this(),"Target")
   name=get_property(this(),"Name")      
   return get_property(target,name)
end function   

method("Get",0,INSTANCE,NORMAL,PUBLIC,routine_id("Delegate_Get_0"),NONE)

function Delegate_Set_1(object newValue) 
   sequence name
   entity target
   if not find(get_property(this(),"Type"),SETTER) then
      throw(Wrong_Delegate_Type)
      return NIL   
   end if 
   target=get_property(this(),"Target")
   name=get_property(this(),"Name")      
   set_property(target,name,newValue)
   return NIL
end function   

method("Set",1,INSTANCE,NORMAL,PUBLIC,routine_id("Delegate_Set_1"),NONE)

function Delegate_Call_1(param_sequence params) 
   sequence name
   entity target
   if not success() then return NIL end if
   if get_property(this(),"Type")!=DELEGATE_METHOD then
      throw(Wrong_Delegate_Type)
      return NIL   
   end if 
   --if length(params)!=get_property(this(),"Param_Count") then
      --throw(Type_Check_Failure)
      --return NIL
  -- end if
   target=get_property(this(),"Target")
   name=get_property(this(),"Name")      
   return call_method(target,name,params)
end function   

method("Call",1,INSTANCE,NORMAL,PUBLIC,routine_id("Delegate_Call_1"),NONE)  

function Delegate_Link_1(valid_handler handler) 
   sequence name
   entity target  
   if not success() then return NIL end if
   if not find(get_property(this(),"Type"),LINKER) then
      throw(Wrong_Delegate_Type)
      return NIL   
   end if 
   target=get_property(this(),"Target")
   name=get_property(this(),"Name") 
   name&=sprintf("#%d",get_property(this(),"Param_Count"))     
   link_handler(target,name,handler)
   return NIL
end function   

method("Link",1,INSTANCE,NORMAL,PUBLIC,routine_id("Delegate_Link_1"),NONE)

function Delegate_Raise_1(param_sequence params) 
   sequence name
   entity target 
   if not success() then return NIL end if
   if not find(get_property(this(),"Type"),RAISER) then
      throw(Wrong_Delegate_Type)
      return NIL   
   end if 
   target=get_property(this(),"Target")
   name=get_property(this(),"Name")      
   raise_event(target,name,params)  
   return NIL
end function   

method("Raise",1,INSTANCE,NORMAL,PUBLIC,routine_id("Delegate_Raise_1"),NONE)

end_class() 


package("Diamond Default")   
               

