-- dsingle.e v4.0.0 by Mike Nelson
-- Diamond Standard Class Library     
-- Instance-counted classes, including Singleton 


without trace    
without warning

include dexcept.e 


package("Diamond Standard Class Library")


global constant Instance_Counted=
class("Instance_Counted",ABSTRACT,Entity,NONE)  

global type is_Instance_Counted(object x)
   return live_instance_check(x,Instance_Counted)   
end type

property("Instances",CLASS,PROTECTED,PRIVATE,TRANSIENT,0)

function Instance_Counted_new_0()
   set_property(this(),"Instances",get_property(this(),"Instances")+1)
   return call_method(super(),"new",NONE)   
end function                             

method("new",0,CLASS,NORMAL,PROTECTED,
routine_id("Instance_Counted_new_0"),NONE)

function Instance_Counted_clone_0()
   set_property(this_class(),"Instances",get_property(this(),"Instances")+1)
   return call_method(super(),"clone",NONE)
end function                        

method("clone",0,INSTANCE,NORMAL,PROTECTED,
routine_id("Instance_Counted_clone_0"),NONE)

function Instance_Counted_delete_0()
   set_property(this_class(),"Instances",get_property(this(),"Instances")-1)
   return call_method(super(),"delete",NONE)   
end function    

method("delete",0,INSTANCE,NORMAL,PROTECTED,
routine_id("Instance_Counted_delete_0"),NONE)

end_class()


global constant Too_Many_Instances=
exception("Too_Many_Instances",Not_Allowed)


global constant Limited_Instances=
class("Limited_Instances",ABSTRACT,Instance_Counted,NONE)  

global type is_Limited_Instances(object x)
   return live_instance_check(x,Limited_Instances)   
end type

property("Limit",CLASS,PROTECTED,PRIVATE,TRANSIENT,0)

function Limited_Instances_Initialize_0()
   object limit
   limit=call_method(this(),"Limit",NONE)
   if not integer(limit) or limit<0 then
      limit=0   
   end if
   set_property(this(),"Limit",limit)
   return NIL
end function       

method("Initialize",0,CLASS,NORMAL,PROTECTED,
routine_id("Limited_Instances_Initialize_0"),NONE)

method("Limit",0,CLASS,NORMAL,PRIVATE,NULL_METHOD,{0}) 

function Limited_Instances_new_0()
   if get_property(this(),"Instances")>=get_property(this(),"Limit") then
      throw(Too_Many_Instances)
      return Null_Instance   
   end if          
   return call_method(super(),"new",NONE)
end function

method("new",0,CLASS,NORMAL,PROTECTED,
routine_id("Limited_Instances_new_0"),NONE)

function Limited_Instances_clone_0()
   if get_property(this_class(),"Instances")>=
   get_property(this_class(),"Limit") then
      throw(Too_Many_Instances)
      return Null_Instance   
   end if          
   return call_method(super(),"clone",NONE)
end function

method("clone",0,INSTANCE,NORMAL,PROTECTED,
routine_id("Limited_Instances_clone_0"),NONE)

end_class()    


global constant Singleton=class("Singleton",ABSTRACT,Limited_Instances,NONE)

global type is_Singleton(object x)
   return live_instance_check(x,Singleton)   
end type


method("Limit",0,CLASS,FINAL,PRIVATE,NULL_METHOD,{1}) 

end_class()     


package("Diamond Default")


